<?

class TextInputComponent extends FormComponent
{
 function TextInputComponent( $label=NULL, $editable=false, $value="", $regId=REG_TEXT, $optional=FALSE ) {
 parent::FormComponent( $label, $editable, $optional );
 $this->d_values["t"] = $value;
 $this->d_values["regid"] = $regId;
 $this->d_values["disabled"] = false;
 }

 function setRegex($regex, $msg) {
 $this->d_values["regex"] = $regex;
 $this->d_values["regexErr"] = $msg ? $msg : $regex;
 }

 






 function getFields() {
 return array_merge( parent::getFields(), array( "t"=>"Just plain text" ) );
 }

 function getFocusableElementName()
 {
 if ( $this->isEditable() )
 return "t";
 return NULL;
 }
 
 function toString()
 {
 return $this->d_values["t"];
 }
 
 function onLoadFinished()
 {
 if ( $this->isHidden() ) return;
 if ( $this->isOptional() && $this->getText() == "" )
 return;
 
 global $REG;
 if ( $REG[$this->d_values["regid"]]["exp"] )
 {
 if ($this->d_values["regex"]) {
 $regex = $this->d_values["regex"];
 $msg = $this->d_values["regexErr"];
 } else {
 $regex = $REG[$this->d_values["regid"]]["exp"];
 $msg = $REG[$this->d_values["regid"]]["desc"];
 }
 if ( !ereg($regex, $this->getText()) )
 {
 $this->addError( new NodeException( $msg ) );
 }
 }
 }
 
 function setText($text) {
 $this->d_values["t"] = $text;
 }

 function getText() {
 return $this->d_values["t"];
 }

 function &getResultObject() {
 node_class("StringObject");
 return new StringObject($this->getText());
 }

 function setObject(&$obj) {
 $this->setText($obj->toString());
 }

 function setDisabled($enabled) {
 $this->d_values["disabled"] = $enabled;
 }

 function isDisabled() {
 return $this->d_values["disabled"];
 }
}

class TextComponent extends TextInputComponent {

 function TextComponent( $label=NULL, $editable=false, $value="", $regId=REG_TEXT, $size=20, $optional=FALSE, $id = null ) {
 parent::TextInputComponent( $label, $editable, $value, $regId, $optional);
 $this->d_values["size"] = $size;
 $this->d_values["htmlid"] = $id;
 }

 function setMaxSize($size) {
 $this->d_values["maxsize"] = $size;
 }

 function setSize($size) {
 $this->d_values["size"] = $size;
 }
 
 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 global $REG;
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $formName = $form->getFormName();
 if ( $this->d_values["regid"] >= 0 || $this->d_values["regex"] )
 {
 $regexId = $this->d_values["regid"];
 if ( $this->d_values["regex"] ) {
 $regex = $this->d_values["regex"];
 $regexErr = $this->d_values["regexErr"];
 } else {
 $regex = $REG[$regexId]["exp"];
 $regexErr = str_replace("\r", "", str_replace("\n", "\\n", $REG[$regexId]["desc"]));
 }
 $optional = $this->isOptional()?"true":"false";
 $form->addJsCheck( array( "checkRegexForField( '$formName', '${fieldPrefix}t', '$regex',".
 "'g', '$regexErr', $optional, focusOnError )", "${fieldPrefix}t" ) );
 }
 $html = "\n<input type=text ";
 $html .= "size=".$this->d_values["size"]." ";
 
 if ( !$this->isEditable() ) {
 $html .= "readonly ";
 }
 if ( $this->isDisabled() ) {
 $html .= "disabled ";
 }

 $syntax = $regexErr;
 if ( $help = $this->createHelpJsEvents( $form, $fieldPrefix, $syntax ) ) {
 $html .= $help["html"]." ";
 }
 
 $html .= $this->getOnKeyDown()." ";
 
 if ($max = $this->d_values["maxsize"]) $html .= "maxsize=$max ";
 if ($this->d_values["htmlid"]) {
 $html .= " id='".$this->d_values["htmlid"]."'";
 }
 $html .= "name=${fieldPrefix}t class=\"solid\" style=\"$strStyle\" value=\"".
 htmlentities_utf8($this->d_values["t"])."\">\n";
 return $this->mergeResult( array( array( NULL, $this->getErrorDiv( $form, $fieldPrefix.'t' ) ) ),
 $this->mergeResult(parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html)
 );
 }
 
}

class TextAreaComponent extends TextInputComponent {

 function TextAreaComponent( $label=NULL, $editable=false, $value="", $regId=REG_TEXT, $optional=FALSE, $rows=5, $cols=20, $sizeStep=0) {
 parent::TextInputComponent( $label, $editable, $value, $regId, $optional);
 $this->d_values["rows"] = $rows;
 $this->d_values["cols"] = $cols;
 $this->d_values["step"] = $sizeStep;
 }

 function _getStepSize( $arr, $step )
 {
 $bigger = FALSE;
 if ( is_array($arr) )
 {
 $c = count($arr);
 if ( $step < $c ) 
 {
 $ret = $arr[$step];
 if ( $step < $c-1 ) $bigger = TRUE;
 }
 else
 $ret = $arr[$c-1];
 }
 else
 $ret = $arr;
 
 return array( "size"=>$ret, "bigger"=>$bigger, "resizable"=>is_array($arr) ); 
 }
 
 function _getDimension() 
 {
 $step = $this->d_values["step"];
 $smaller = $step > 0;
 $rows = $this->_getStepSize( $this->d_values["rows"], $step );
 $cols = $this->_getStepSize( $this->d_values["cols"], $step );
 return array(
 "rows"=>$rows["size"], "cols"=>$cols["size"], "smaller"=>$smaller,
 "bigger"=>($rows["bigger"] || $cols["bigger"]),
 "resizable"=>($rows["resizable"] || $cols["resizable"] ) 
 );

 }
 
 function getRows()
 {
 $dim = $this->_getDimension();
 return $dim["rows"];
 }
 
 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 global $REG;
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $formName = $form->getFormName();
 $dim = $this->_getDimension();
 if ( $this->d_values["regid"] >= 0 || $this->d_values["regex"] )
 {
 if ($this->d_values["regid"]) {
 $regexId = $this->d_values["regid"];
 $regex = $REG[$regexId]["exp"];
 $regexErr = $REG[$regexId]["desc"];
 } else {
 $regex = $this->d_values["regex"];
 $regexErr = $this->d_values["regexErr"];
 }
 $optional = $this->isOptional()?"true":"false";
 $form->addJsCheck( array( "checkRegexForField( '$formName', '${fieldPrefix}t', '$regex',".
 "'g', '$regexErr', $optional, focusOnError )", "${fieldPrefix}t" ) );
 }

 $action = $form->getJsButtonActionCall( $form->getDefaultButtonName() );
 $this->setShortcut((VK_ENTER | VK_MOD_CTRL), $action, FALSE);
 $this->setShortcut(VK_ENTER, $action, FALSE);
 
 $html = "\n<table cellpadding=0 cellspacing=0 border=0>\n<tr><td>";
 if ( $dim["rows"] == 1 )
 {
 $strStyle .= "overflow:hidden; ";
 }
 else
 $this->removeShortcut( VK_ENTER );

 
 if ( $dim["resizable"] )
 {
 global $ICO_BIGGER, $ICO_SMALLER, $ICO_BIGGER_GREY, $ICO_SMALLER_GREY;
 if ( $dim["bigger"] )
 {
 $biglink = $form->getJsActionCall( new ValueSetterFormAction($key, "step", $this->d_values["step"] + 1) );
 $bigger = "<a href=\"javascript:$biglink\">".img($ICO_BIGGER, 0, i18n("Make Textbox bigger"))."</a>";
 $this->setShortcut( VK_KP_PLUS | VK_MOD_SHIFT, $biglink );
 }
 else
 {
 $bigger = img($ICO_BIGGER_GREY);
 $this->removeShortcut( VK_KP_PLUS | VK_MOD_SHIFT );
 }
 
 if ( $dim["smaller"] )
 {
 $smalllink = $form->getJsActionCall( new ValueSetterFormAction($key, "step", $this->d_values["step"] - 1) );
 $smaller = "<a href=\"javascript:$smalllink\">".img($ICO_SMALLER, 0, i18n("Make Textbox smaller"))."</a>";
 $this->setShortcut( VK_KP_MINUS | VK_MOD_SHIFT, $smalllink );
 } 
 else
 {
 $smaller = img($ICO_SMALLER_GREY);
 $this->removeShortcut( VK_KP_MINUS | VK_MOD_SHIFT );
 }
 
 }
 
 $onkeydown = "\n".$this->getOnKeyDown();
 
 $html .= "<textarea name=${fieldPrefix}t class=\"solid\" \nstyle=\"$strStyle\" $onkeydown\n";
 $html .= " rows=".$dim["rows"];
 $html .= " cols=".$dim["cols"];
 if (!$this->isEditable()) {
 $html .= " disabled";
 }
 
 $syntax = $regexErr;
 if ( $help = $this->createHelpJsEvents( $form, $fieldPrefix, $syntax ) ) {
 $html .= " ".$help["html"]." ";
 }
 
 $html .= ">".htmlentities_utf8($this->d_values["t"])."</textarea>";
 $html .= "</td>\n";
 if ( $dim["resizable"] )
 $html .= "<td>$bigger</td><td>$smaller</td>";
 
 $html .= "</tr>\n</table>";
 return $this->mergeResult( array( array( NULL, $this->getErrorDiv( $form, $fieldPrefix.'t' ) ) ),
 $this->mergeResult(parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html)
 );
 }
}

class HiddenComponent extends FormComponent
{
 function HiddenComponent( $value ) {
 parent::FormComponent();
 $this->setValue( $value );
 }

 function getValue()
 {
 return $this->d_values["hidden"];
 }
 
 function setValue( $value )
 {
 $this->d_values["hidden"] = $value;
 }
 
 function &getResultObject() {
 if ( is_object( $this->d_values["hidden"] ) )
 return $this->d_values["hidden"];
 return new NodeException( i18n( "HiddenComponent: value is not an object." ) );
 }
}


class PasswordComponent extends TextComponent {

 function PasswordComponent($label=NULL, $editable=false, $value="", $regId=REG_TEXT, $size=20, $optional=FALSE) {
 parent::TextComponent($label, $editable, $value, $regId, $size, $optional);
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 global $REG;
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $formName = $form->getFormName();
 if ( $this->d_values["regid"] >= 0 || $this->d_values["regex"] )
 {
 $regexId = $this->d_values["regid"];
 if ( $this->d_values["regex"] ) {
 $regex = $this->d_values["regex"];
 $regexErr = $this->d_values["regexErr"];
 } else {
 $regex = $REG[$regexId]["exp"];
 $regexErr = str_replace("\r", "", str_replace("\n", "\\n", $REG[$regexId]["desc"]));
 }
 $optional = $this->isOptional()?"true":"false";
 $form->addJsCheck( array( "checkRegexForField( '$formName', '${fieldPrefix}t', '$regex',".
 "'g', '$regexErr', $optional, focusOnError )", "${fieldPrefix}t" ) );
 }
 $html = "\n<input type=password ";
 $html .= "size=".$this->d_values["size"]." ";
 
 if ( !$this->isEditable() ) {
 $html .= "readonly ";
 }
 if ( $this->isDisabled() ) {
 $html .= "disabled ";
 }

 $syntax = $regexErr;
 if ( $help = $this->createHelpJsEvents( $form, $fieldPrefix, $syntax ) ) {
 $html .= $help["html"]." ";
 }
 
 $html .= $this->getOnKeyDown()." ";
 
 if ($max = $this->d_values["maxsize"]) $html .= "maxsize=$max ";
 $html .= "name=${fieldPrefix}t class=\"solid\" style=\"$strStyle\"\">\n";
 return $this->mergeResult( array( array( NULL, $this->getErrorDiv( $form, $fieldPrefix.'t' ) ) ),
 $html
 );
 }
}




class PasswordInputComponent extends FormComponent {

 function PasswordInputComponent() {

 }


 function &getResultObject() {
 
 }

 function reset() {
 
 }

 function getSerializeKey() {
 $rs["parent"] = parent::getSerializeKey();

 return $rs;
 }

 function initFromSerializeKey( $key ) {
 parent::initFromSerializeKey( $key["parent"] );
 
 }

 function onLoadFinished() {

 }

 function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key ) {

 }

 function isFinished() {

 }

}

?>
