<?

function cmd_objprop_create($name,$cid,$type,$required = NULL,$inpage = NULL,$inheritable = NULL) {

 if (!$cid || !$name || !$type) halt(7,"cmd_objprop_create: invalid parameters name($name) type($type) cid($cid)");

 global $ERROR, $T_TYPE, $T_OBJPROP, $W_CREATE, $FEATURE, $T_OBJPROPELEMENT;

 $name = sqlslashes($name);
 $prename = $T_TYPE[$type]["key"];
 $name = "$prename.$name";
 $sql = "SELECT count(id) AS c FROM objtag WHERE name = '".sqlf_escaped($name)."' AND obj_type = ".sqlf_tl_num($type)." AND obj_id = 0";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["name"] = i18n("Es existiert bereits eine Eigenschaft mit diesem Namen.");
 return false;
 }
 if ($FEATURE['template_objprop']) {
 $sql = "SELECT count(id) AS c FROM objtag WHERE name = '".sqlf_escaped($name)."' AND construct_id != ".sqlf_tl_num($cid)." AND obj_id = 0";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["name"] = i18n("Es existiert bereits eine Eigenschaft mit diesem Namen jedoch mit einem unterschiedlichen Typ.");
 return false;
 }
 }
 $sql = "INSERT INTO objtag (name,construct_id,obj_type) VALUES ('".sqlf_escaped($name)."',".sqlf_tl_num($cid).",".sqlf_tl_num($type).")";
 $rs = query($sql);

 duplicate_perm( $T_OBJPROP, $type, $T_OBJPROPELEMENT, $rs['iid'] );

 if( $required !== NULL || $inpage !== NULL || $inheritable !== NULL ) {
 $sql = '';
 if($required !== NULL) {
 $sql .= "required = '".sqlf_escaped($required)."'";
 }
 if($inpage !== NULL) {
 if($sql) $sql .= ',';
 $sql .= "inpage = '".sqlf_escaped($inpage)."'";
 }
 if($inheritable !== NULL) {
 if($sql) $sql .= ',';
 $sql .= "inheritable = '".sqlf_escaped($inheritable)."'";
 }
 $sql = "UPDATE objtag SET $sql WHERE name = '".sqlf_escaped($name)."' AND obj_type = '".sqlf_escaped($type)."'";
 query( $sql );
 }


 logcmd($W_CREATE,$T_OBJPROP,$type,$cid,$name);
 
 return $rs["iid"];

}

function cmd_objprop_update($id,$name,$cid,$type,$required = NULL,$inpage = NULL,$inheritable = NULL) {

 if (!$cid || !$id || !$name || !$type) halt(7,"cmd_objprop_update: invalid parameters id($id) name($name) type($type) cid($cid)");

 global $ERROR, $T_TYPE, $W_EDIT, $T_OBJPROP;
 $name = sqlslashes($name);
 $prename = $T_TYPE[$type]["key"];
 $name = "$prename.$name";

 $sql = "SELECT count(id) AS c FROM objtag WHERE name = '".sqlf_escaped($name)."' AND obj_type = ".sqlf_tl_num($type)." AND obj_id = 0 AND id != ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["name"] = i18n("Es existiert bereits eine Eigenschaft mit diesem Namen.");
 return false;
 }
 if ($FEATURE['template_objprop']) {
 $sql = "SELECT count(id) AS c FROM objtag WHERE name = '".sqlf_escaped($name)."' AND construct_id != ".sqlf_tl_num($cid)." AND obj_id = 0";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["name"] = i18n("Es existiert bereits eine Eigenschaft mit diesem Namen f�r ein anderes Objekt, jedoch mit einem unterschiedlichen Typ.");
 return false;
 }
 }
 $sql = "UPDATE objtag SET name = '".sqlf_escaped($name)."', construct_id = ".sqlf_tl_num($cid)." WHERE id = ".sqlf_tl_num($id);
 query($sql);

 if( $required !== NULL || $inpage !== NULL || $inheritable !== NULL ) {
 $sql = '';
 if($required !== NULL) {
 $sql .= "required = '".sqlf_escaped($required)."'";
 }
 if($inpage !== NULL) {
 if($sql) $sql .= ',';
 $sql .= "inpage = '".sqlf_escaped($inpage)."'";
 }
 if($inheritable !== NULL) {
 if($sql) $sql .= ',';
 $sql .= "inheritable = '".sqlf_escaped($inheritable)."'";
 }
 $sql = "UPDATE objtag SET $sql WHERE name = '".sqlf_escaped($name)."' AND obj_type = '".sqlf_escaped($type)."'";
 query( $sql );
 }

 logcmd($W_EDIT,$T_OBJPROP,$type,$cid,$name);

 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache(T_OBJPROPELEMENT, $id);

 return true;

}

function cmd_objprop_del($id) {

 global $DEBUG, $W_DEL, $T_OBJPROP, $T_FOLDER, $T_TEMPLATE, $T_PAGE, $T_IMAGE, $T_FILE;

 if (!is_array($id)) halt(7,"cmd_objprop_del: invalid id($id)");
 while (list($key,$val) = each($id)) {
 $sql = "SELECT name, obj_type FROM objtag WHERE id = ".sqlf_tl_num($key);
 if ($DEBUG['objprop']) echo "get obj info <br>$sql<hr>";
 $rs = query($sql);
 $name = $rs["arr"][0]["name"];
 $type = $rs["arr"][0]["obj_type"];
 $info["id"] = $key;
 logcmd($W_DEL,$T_OBJPROP,$key,0,$name);
 if ($type == $T_FOLDER) {
 $sql1 = "SELECT id FROM folder";
 } else if ($type == $T_TEMPLATE) {
 $sql1 = "SELECT id FROM template";
 } else if ($type == $T_PAGE) {
 $sql1 = "SELECT id FROM page";
 } else if ($type == $T_FILE || $type == $T_IMAGE) {
 $sql1 = "SELECT id FROM contentfile";
 }
 if ($sql1) {
 $rs = query($sql1);
 $arr = reduce_array($rs['arr'],'id','id');
 sync_obj_types($arr, $type, $key, true);
 }
 tags_del(0,"obj",$info);
 }
}

 
function sync_obj_types ($ids, $obj_type, $objtag_id, $del_objprop = false) {
 
 global $DEBUG, $FEATURE, $T_FOLDER, $T_TEMPLATE, $T_PAGE, $T_IMAGE, $T_FILE;

 $ignore = false;
 
 
 $sql = "SELECT name FROM objtag where id = ".sqlf_tl_num($objtag_id);
 $rs = query($sql);
 $name = $rs['arr'][0]['name'];

 
 if ($obj_type != $T_PAGE) {
 $sql = "SELECT objtag.id FROM objtag, construct
		WHERE objtag.obj_type = ".sqlf_tl_num($T_PAGE)." AND objtag.obj_id = 0 
		AND objtag.construct_id = construct.id AND name = '".sqlf_escaped($name)."'";
 if ($DEBUG['objprop']) echo "check if we got a global page property with the same name.<br>$sql<hr>";
 $rs = query($sql);
 if ($rs['num'] > 0) {
 $ignore = true;
 if ($DEBUG['objprop']) echo "IGNORE:page.prop<br>";
 }
 }
 
 
 if (is_array($ids) && ($obj_type == $T_FOLDER || $obj_type == $T_TEMPLATE || $obj_type == $T_PAGE || $obj_type == $T_IMAGE || $obj_type == $T_FILE)) {
 if ($DEBUG['objprop']) echo "Checking ".serialize($ids)."<br>";
 $arr_in = array();
 foreach ($ids as $id=>$a) {
 $rsobjtag = array();
 
 if ( $del_objprop ) {
 $sql = "SELECT id FROM objtag WHERE obj_type = ".sqlf_tl_num($obj_type)." AND obj_id = ".sqlf_tl_num($id)." AND name = '".sqlf_escaped($name)."'";
 if ( $DEBUG['objprop'] ) echo "Getting tag for obj_type ($obj_type) obj_id ($id) name ($name)<br>";
 $rsobjtag = query($sql);
 if ( $rsobjtag['num'] > 0 ) {
 $info = array();
 $info["id"] = $rsobjtag['arr'][0]['id'];
 if ($DEBUG['objprop']) echo "Delete tag<br>tags_del(0,'obj',array('id'=>". $rsobjtag['arr'][0]['id'].")<hr>";
 tags_del(0, 'obj', $info );
 }
 }
 
 if (!$ignore) {
 if ($DEBUG['objprop']) echo "Checking ------------($id)-------------<br>";
 if ($obj_type == $T_FOLDER) {
 $sql = "SELECT page.id AS page_id FROM objtag, page
					WHERE objtag.obj_type = ".sqlf_tl_num($T_TEMPLATE)." AND objtag.inpage = 1 AND objtag.name = '".sqlf_escaped($name)."'
					AND objtag.obj_id = page.template_id AND page.folder_id = ".sqlf_tl_num($id);
 if ($DEBUG['objprop']) echo "folder prop (id:$id): check if we got an template prop in a page editable.<br>$sql<hr>";
 } elseif ($obj_type == $T_TEMPLATE) {
 $sql = "SELECT page.id AS page_id FROM objtag, page
					WHERE objtag.obj_type = ".sqlf_tl_num($T_FOLDER)." AND objtag.inpage = 1 AND objtag.name = '".sqlf_escaped($name)."'
					AND objtag.obj_id = page.folder_id AND page.template_id = ".sqlf_tl_num($id);
 if ($DEBUG['objprop']) echo "template prop (id:$id): check if we got an folder prop in page editable.<br>$sql<hr>";
 } else {
 $sql = "SELECT page.id AS page_id FROM objtag, page
					WHERE (objtag.obj_type = ".sqlf_tl_num($T_FOLDER)." OR objtag.obj_type = ".sqlf_tl_num($T_TEMPLATE).")
					AND (objtag.obj_id = page.folder_id OR objtag.obj_id = page.template_id)
					AND objtag.inpage = 1 AND objtag.name = '".sqlf_escaped($name)."'
					AND page.id = ".sqlf_tl_num($id);
 if ($DEBUG['objprop']) echo "page prop (id:$id): check if we got an template or folder prop in page editable.<br>$sql<hr>";
 }

 
 $rs = query($sql);
 if ($rs['num'] > 0) {
 foreach ($rs['arr'] as $v)
 $arr_in[$v['page_id']] = $v;
 if ($DEBUG['objprop']) echo "ignore for page ".$v['page_id']."<br>";
 }
 }
 }

 $in = sql_in($arr_in, 'page_id');

 
 if ( ( $obj_type == $T_TEMPLATE || $obj_type == $T_FOLDER || $obj_type == $T_PAGE) && !$ignore ) {
 reset($ids);
 foreach ($ids as $id=>$a) {

 
 if ( $obj_type == $T_TEMPLATE ) {
 $where = ", page WHERE objtag.obj_id = page.id AND page.template_id = ".sqlf_tl_num($id)." AND "; 
 } else if ($obj_type == $T_FOLDER ) {
 $where = ", page WHERE objtag.obj_id = page.id AND page.folder_id = ".sqlf_tl_num($id)." AND "; 
 } else {
 $where = " WHERE ";
 }
 if ($in) {
 $sql = "SELECT objtag.id, objtag.obj_id FROM objtag $where objtag.obj_type = ".sqlf_tl_num($T_PAGE)." AND objtag.name = '".sqlf_escaped($name)."' AND objtag.obj_id NOT IN $in";
 } else {
 $sql = "SELECT objtag.id, objtag.obj_id FROM objtag $where objtag.obj_type = ".sqlf_tl_num($T_PAGE)." AND objtag.name = '".sqlf_escaped($name)."'";
 } 

 if ($DEBUG['objprop']) echo "SELECT page prop tags<br> $sql<hr>";
 $rs = query($sql);

 if ($rs['num'] > 0) {
 foreach ($rs['arr'] as $v) {
 if (!$pagetag_done[$v['id']]) {
 if ($DEBUG['objprop']) echo "Delete page tags<br>tags_del(".$v['id'].",'obj',array('name'=>$name, 'obj_type'=>$T_PAGE))<hr>";
 tags_del($v['obj_id'],'obj',array('name'=>$name, 'obj_type'=>$T_PAGE, 'id'=>$v['id']));
 $pagetag_done[$v['id']] = true;
 } else {
 if ($DEBUG['objprop']) echo "Page tag alread deleted (".$v['id'].").<hr>";
 }
 }
 } else {
 if ($DEBUG['objprop']) echo "Nothing to do. No pages found.<hr>";
 }
 }
 }
 }
}


function sql_in ($arr, $col) {
 $in = '';
 if (is_array($arr))
 foreach ($arr as $v) {
 if ($in) {
 $in .= ", ".sqlf_value($v[$col]);
 } else {
 $in = "(".sqlf_value($v[$col]);
 }
 }
 if ($in) $in .= ")";
 return $in;
}
?>
