<?

node_class( 'nodeexception' );

function object2xml( &$obj, $depth ) {
 if( $obj === NULL ) return '<null />';
 if( is_array( $obj ) ) {
 $ret = '';
 foreach( $obj as $o ) {
 $ret .= object2xml( $o, $depth + 1 );
 }
 return $ret;
 }
 if( is_a( $obj, 'collection' ) ) {
 $i = $obj->iterator();
 $ret = '';
 while( $i->hasNext() ) {
 $ret .= object2xml( $i->next(), $depth + 1 );
 }
 return $ret;
 }

 if( is_a( $obj, 'cnobject' )) {
 $props = array_merge($obj->getPropertyNames(), $obj->getValueFields());
 $ret = '<'.get_class( $obj ).' objid="'.$obj->getID().'">';
 if( $depth < 2 ) {
 foreach( $props as $key => $value ) {
 $val = $obj->getProperty( $key );
 if( is_a( $val, 'nodeexception' ) ) {
 $val = $obj->getFieldValue( $key );
 }
 $ret .= "<$key>".object2xml( $val, $depth+1 )."</$key>";
 }
 }
 $ret .= '</'.get_class( $obj ).'>';
 return $ret;
 }
 if( is_a( $obj, 'baseobject' ) ) {
 return htmlspecialchars($obj->toString());
 }
 if( is_bool( $obj ) ) {
 return $obj ? '<true />' : '<false />';
 }
 if( is_scalar( $obj ) ) {
 return htmlspecialchars($obj);
 }
 return '<undefined class="'.get_class( $obj ).'" />';
}

$output = '';

$restfunc = $RESTFUNCTIONS[$func];

if( ! $restfunc || ! $FEATURE['restapi'] ) {
 header('Status: 404 Not Found');
 exit();
}

header('Content-Type: text/xml');

$ret = $restfunc['func']($args);

$output = '<result>';

$startdepth = 0;

if( $restfunc['startdepth'] ) $startdepth = $restfunc['startdepth'];

$output .= object2xml( $ret, $startdepth );

$output .= '</result>';


echo $output;
exit();

?>